package com.dashitech.utils;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.dom4j.*;

import java.io.File;
import java.io.FileInputStream;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.List;

/**
 * Created by xuweihua on 2020/8/27.
 */
public class XmlToJson {
    public static void main(String[] args) throws Exception {
//        String xmlStr= readFile("D:/ADA/et/Issue_20130506_back.xml");
        String xmlStr= "<HL7Message><MSH><MSH.1>|</MSH.1><MSH.2>~^\\&amp;</MSH.2><MSH.3>HIS</MSH.3><MSH.4></MSH.4><MSH.5>ESB</MSH.5><MSH.6></MSH.6><MSH.7>20160504151811</MSH.7><MSH.8></MSH.8><MSH.9><MSH.9.1>ADT</MSH.9.1><MSH.9.2>A01</MSH.9.2><MSH.9.3>ADT_A01</MSH.9.3></MSH.9><MSH.10>7da1c62e-c7d2-4616-8bf5-06c2b9388b98</MSH.10><MSH.11>P</MSH.11><MSH.12>2.6</MSH.12><MSH.13></MSH.13><MSH.14></MSH.14><MSH.15>NE</MSH.15><MSH.16>AL</MSH.16><MSH.17></MSH.17><MSH.18>utf-8</MSH.18></MSH><EVN><EVN.1>C</EVN.1><EVN.2>20160504151811</EVN.2><EVN.3></EVN.3><EVN.4></EVN.4><EVN.5><EVN.5.1>820964</EVN.5.1><EVN.5.2>陈娟</EVN.5.2></EVN.5></EVN><PID><PID.1></PID.1><PID.2>1005122721</PID.2><PID.3></PID.3><PID.4></PID.4><PID.5><PID.5.1>涂松林</PID.5.1><PID.5.2></PID.5.2><PID.5.3></PID.5.3><PID.5.4>TU SONG LIN</PID.5.4></PID.5><PID.6></PID.6><PID.7>19570726000000</PID.7><PID.8>1</PID.8><PID.9></PID.9><PID.10></PID.10><PID.11>&amp;兰溪镇鲇鱼尾村四组 </PID.11></PID><PV1><PV1.1></PV1.1><PV1.2>2</PV1.2><PV1.3/><PV1.4></PV1.4><PV1.5></PV1.5><PV1.6></PV1.6><PV1.7></PV1.7><PV1.8></PV1.8><PV1.9></PV1.9><PV1.10></PV1.10><PV1.11></PV1.11><PV1.12></PV1.12><PV1.13></PV1.13><PV1.14></PV1.14><PV1.15></PV1.15><PV1.16></PV1.16><PV1.17></PV1.17><PV1.18></PV1.18><PV1.19>1</PV1.19><PV1.20></PV1.20><PV1.21></PV1.21><PV1.22></PV1.22><PV1.23></PV1.23><PV1.24></PV1.24><PV1.25></PV1.25><PV1.26></PV1.26><PV1.27></PV1.27><PV1.28></PV1.28><PV1.29></PV1.29><PV1.30></PV1.30><PV1.31></PV1.31><PV1.32></PV1.32><PV1.33></PV1.33><PV1.34></PV1.34><PV1.35></PV1.35><PV1.36></PV1.36><PV1.37></PV1.37><PV1.38></PV1.38><PV1.39>H0002</PV1.39><PV1.40></PV1.40><PV1.41></PV1.41><PV1.42></PV1.42><PV1.43></PV1.43><PV1.44>20160504114100</PV1.44></PV1><DG1><DG1.1>1</DG1.1><DG1.2></DG1.2><DG1.3><DG1.3.1>R06.002</DG1.3.1><DG1.3.2>胸闷</DG1.3.2></DG1.3><DG1.4></DG1.4><DG1.5></DG1.5><DG1.6>A</DG1.6></DG1><IN1><IN1.1>1</IN1.1><IN1.2><IN1.2.1>A</IN1.2.1><IN1.2.2>自费</IN1.2.2></IN1.2><IN1.3>NONE</IN1.3></IN1></HL7Message>";
        Document doc= DocumentHelper.parseText(xmlStr);
        JSONObject json=new JSONObject();
        dom4j2Json(doc.getRootElement(),json);
        System.out.println("xml2Json:"+json.toJSONString());

    }

    public static String readFile(String path) throws Exception {
        File file=new File(path);
        FileInputStream fis = new FileInputStream(file);
        FileChannel fc = fis.getChannel();
        ByteBuffer bb = ByteBuffer.allocate(new Long(file.length()).intValue());
        //fc向buffer中读入数据
        fc.read(bb);
        bb.flip();
        String str=new String(bb.array(),"UTF8");
        fc.close();
        fis.close();
        return str;

    }
    /**
     * xml转json
     * @param xmlStr
     * @return
     * @throws DocumentException
     */
    public static JSONObject xml2Json(String xmlStr) throws DocumentException{
        Document doc= DocumentHelper.parseText(xmlStr);
        JSONObject json=new JSONObject();
        dom4j2Json(doc.getRootElement(), json);
        return json;
    }

    /**
     * xml转json
     * @param element
     * @param json
     */
    public static void dom4j2Json(Element element,JSONObject json){
        //如果是属性
        for(Object o:element.attributes()){
            Attribute attr=(Attribute)o;
            if(!isEmpty(attr.getValue())){
                json.put("@"+attr.getName(), attr.getValue());
            }
        }
        List<Element> chdEl=element.elements();
        if(chdEl.isEmpty()&&!isEmpty(element.getText())){//如果没有子元素,只有一个值
            json.put(element.getName(), element.getText());
        }

        for(Element e:chdEl){//有子元素
            if(!e.elements().isEmpty()){//子元素也有子元素
                JSONObject chdjson=new JSONObject();
                dom4j2Json(e,chdjson);
                Object o=json.get(e.getName());
                if(o!=null){
                    JSONArray jsona=null;
                    if(o instanceof JSONObject){//如果此元素已存在,则转为jsonArray
                        JSONObject jsono=(JSONObject)o;
                        json.remove(e.getName());
                        jsona=new JSONArray();
                        jsona.add(jsono);
                        jsona.add(chdjson);
                    }
                    if(o instanceof JSONArray){
                        jsona=(JSONArray)o;
                        jsona.add(chdjson);
                    }
                    json.put(e.getName(), jsona);
                }else{
                    if(!chdjson.isEmpty()){
                        json.put(e.getName(), chdjson);
                    }
                }


            }else{//子元素没有子元素
                for(Object o:element.attributes()){
                    Attribute attr=(Attribute)o;
                    if(!isEmpty(attr.getValue())){
                        json.put("@"+attr.getName(), attr.getValue());
                    }
                }
                if(!e.getText().isEmpty()){
                    json.put(e.getName(), e.getText());
                }
            }
        }
    }

    public static boolean isEmpty(String str) {

        if (str == null || str.trim().isEmpty() || "null".equals(str)) {
            return true;
        }
        return false;
    }
}
